<?php

namespace WpifyWoo\PacketeraSDK\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Barcode ServiceType
 * @subpackage Services
 */
class Barcode extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named barcodePng
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $barcode
     * @return base64Binary|bool
     */
    public function barcodePng($apiPassword, $barcode)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('barcodePng', array(
                $apiPassword,
                $barcode,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return base64Binary
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
