<?php

namespace WpifyWoo\PacketeraSDK\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Packets ServiceType
 * @subpackage Services
 */
class Packets extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named packetsLabelsPdf
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketIds $packetIds
     * @param string $format
     * @param string $offset
     * @return base64Binary|bool
     */
    public function packetsLabelsPdf($apiPassword, \WpifyWoo\PacketeraSDK\StructType\PacketIds $packetIds, $format, $offset)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetsLabelsPdf', array(
                $apiPassword,
                $packetIds,
                $format,
                $offset,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named packetsCourierLabelsPdf
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param \WpifyWoo\PacketeraSDK\StructType\PacketIdsWithCourierNumbers $packetIdsWithCourierNumbers
     * @param string $offset
     * @param string $format
     * @return base64Binary|bool
     */
    public function packetsCourierLabelsPdf($apiPassword, \WpifyWoo\PacketeraSDK\StructType\PacketIdsWithCourierNumbers $packetIdsWithCourierNumbers, $offset, $format)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('packetsCourierLabelsPdf', array(
                $apiPassword,
                $packetIdsWithCourierNumbers,
                $offset,
                $format,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return base64Binary
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
