<?php

namespace WpifyWoo\PacketeraSDK\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Update ServiceType
 * @subpackage Services
 */
class Update extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named updatePacket
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param string $apiPassword
     * @param string $packetId
     * @param \WpifyWoo\PacketeraSDK\StructType\UpdatePacketAttributes $updateAttributes
     * @return void|bool
     */
    public function updatePacket($apiPassword, $packetId, \WpifyWoo\PacketeraSDK\StructType\UpdatePacketAttributes $updateAttributes)
    {
        try {
            $this->setResult($this->getSoapClient()->__soapCall('updatePacket', array(
                $apiPassword,
                $packetId,
                $updateAttributes,
            ), array(), array(), $this->outputHeaders));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return void
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
