<?php

namespace WpifyWoo\PacketeraSDK\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AttributeFault StructType
 * @subpackage Structs
 */
class AttributeFault extends AbstractStructBase
{
    /**
     * The name
     * @var string
     */
    public $name;
    /**
     * The fault
     * @var string
     */
    public $fault;
    /**
     * The field
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $field;
    /**
     * Constructor method for AttributeFault
     * @uses AttributeFault::setName()
     * @uses AttributeFault::setFault()
     * @uses AttributeFault::setField()
     * @param string $name
     * @param string $fault
     * @param string $field
     */
    public function __construct($name = null, $fault = null, $field = null)
    {
        $this
            ->setName($name)
            ->setFault($fault)
            ->setField($field);
    }
    /**
     * Get name value
     * @return string|null
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \WpifyWoo\PacketeraSDK\StructType\AttributeFault
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get fault value
     * @return string|null
     */
    public function getFault()
    {
        return $this->fault;
    }
    /**
     * Set fault value
     * @param string $fault
     * @return \WpifyWoo\PacketeraSDK\StructType\AttributeFault
     */
    public function setFault($fault = null)
    {
        // validation for constraint: string
        if (!is_null($fault) && !is_string($fault)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fault, true), gettype($fault)), __LINE__);
        }
        $this->fault = $fault;
        return $this;
    }
    /**
     * Get field value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getField()
    {
        return isset($this->field) ? $this->field : null;
    }
    /**
     * Set field value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $field
     * @return \WpifyWoo\PacketeraSDK\StructType\AttributeFault
     */
    public function setField($field = null)
    {
        // validation for constraint: string
        if (!is_null($field) && !is_string($field)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($field, true), gettype($field)), __LINE__);
        }
        if (is_null($field) || (is_array($field) && empty($field))) {
            unset($this->field);
        } else {
            $this->field = $field;
        }
        return $this;
    }
}
