<?php

namespace WpifyWoo\PacketeraSDK\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomsDeclarationItem StructType
 * @subpackage Structs
 */
class CustomsDeclarationItem extends AbstractStructBase
{
    /**
     * The customsCode
     * @var string
     */
    public $customsCode;
    /**
     * The valueEur
     * Meta information extracted from the WSDL
     * - base: xsd:decimal
     * - fractionDigits: 2
     * @var float
     */
    public $valueEur;
    /**
     * The value
     * Meta information extracted from the WSDL
     * - base: xsd:decimal
     * - fractionDigits: 2
     * @var float
     */
    public $value;
    /**
     * The productEan
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 24
     * @var string
     */
    public $productEan;
    /**
     * The productNameEn
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 32
     * @var string
     */
    public $productNameEn;
    /**
     * The productName
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 32
     * @var string
     */
    public $productName;
    /**
     * The unitsCount
     * Meta information extracted from the WSDL
     * - default: 0
     * @var int
     */
    public $unitsCount;
    /**
     * The countryOfOrigin
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 16
     * @var string
     */
    public $countryOfOrigin;
    /**
     * The currency
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 16
     * - minOccurs: 0
     * @var string
     */
    public $currency;
    /**
     * The invoiceNumber
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 16
     * - minOccurs: 0
     * @var string
     */
    public $invoiceNumber;
    /**
     * The invoiceIssueDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $invoiceIssueDate;
    /**
     * The weight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $weight;
    /**
     * The isFoodBook
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $isFoodBook;
    /**
     * The isVoc
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $isVoc;
    /**
     * Constructor method for CustomsDeclarationItem
     * @uses CustomsDeclarationItem::setCustomsCode()
     * @uses CustomsDeclarationItem::setValueEur()
     * @uses CustomsDeclarationItem::setValue()
     * @uses CustomsDeclarationItem::setProductEan()
     * @uses CustomsDeclarationItem::setProductNameEn()
     * @uses CustomsDeclarationItem::setProductName()
     * @uses CustomsDeclarationItem::setUnitsCount()
     * @uses CustomsDeclarationItem::setCountryOfOrigin()
     * @uses CustomsDeclarationItem::setCurrency()
     * @uses CustomsDeclarationItem::setInvoiceNumber()
     * @uses CustomsDeclarationItem::setInvoiceIssueDate()
     * @uses CustomsDeclarationItem::setWeight()
     * @uses CustomsDeclarationItem::setIsFoodBook()
     * @uses CustomsDeclarationItem::setIsVoc()
     * @param string $customsCode
     * @param float $valueEur
     * @param float $value
     * @param string $productEan
     * @param string $productNameEn
     * @param string $productName
     * @param int $unitsCount
     * @param string $countryOfOrigin
     * @param string $currency
     * @param string $invoiceNumber
     * @param string $invoiceIssueDate
     * @param int $weight
     * @param bool $isFoodBook
     * @param bool $isVoc
     */
    public function __construct($customsCode = null, $valueEur = null, $value = null, $productEan = null, $productNameEn = null, $productName = null, $unitsCount = 0, $countryOfOrigin = null, $currency = null, $invoiceNumber = null, $invoiceIssueDate = null, $weight = null, $isFoodBook = null, $isVoc = null)
    {
        $this
            ->setCustomsCode($customsCode)
            ->setValueEur($valueEur)
            ->setValue($value)
            ->setProductEan($productEan)
            ->setProductNameEn($productNameEn)
            ->setProductName($productName)
            ->setUnitsCount($unitsCount)
            ->setCountryOfOrigin($countryOfOrigin)
            ->setCurrency($currency)
            ->setInvoiceNumber($invoiceNumber)
            ->setInvoiceIssueDate($invoiceIssueDate)
            ->setWeight($weight)
            ->setIsFoodBook($isFoodBook)
            ->setIsVoc($isVoc);
    }
    /**
     * Get customsCode value
     * @return string|null
     */
    public function getCustomsCode()
    {
        return $this->customsCode;
    }
    /**
     * Set customsCode value
     * @param string $customsCode
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setCustomsCode($customsCode = null)
    {
        // validation for constraint: string
        if (!is_null($customsCode) && !is_string($customsCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customsCode, true), gettype($customsCode)), __LINE__);
        }
        $this->customsCode = $customsCode;
        return $this;
    }
    /**
     * Get valueEur value
     * @return float|null
     */
    public function getValueEur()
    {
        return $this->valueEur;
    }
    /**
     * Set valueEur value
     * @param float $valueEur
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setValueEur($valueEur = null)
    {
        // validation for constraint: float
        if (!is_null($valueEur) && !(is_float($valueEur) || is_numeric($valueEur))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($valueEur, true), gettype($valueEur)), __LINE__);
        }
        // validation for constraint: fractionDigits(2)
        if (!is_null($valueEur) && mb_strlen(mb_substr($valueEur, false !== mb_strpos($valueEur, '.') ? mb_strpos($valueEur, '.') + 1 : mb_strlen($valueEur))) > 2) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must at most contain 2 fraction digits, %d given', var_export($valueEur, true), mb_strlen(mb_substr($valueEur, mb_strpos($valueEur, '.') + 1))), __LINE__);
        }
        $this->valueEur = $valueEur;
        return $this;
    }
    /**
     * Get value value
     * @return float|null
     */
    public function getValue()
    {
        return $this->value;
    }
    /**
     * Set value value
     * @param float $value
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setValue($value = null)
    {
        // validation for constraint: float
        if (!is_null($value) && !(is_float($value) || is_numeric($value))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        // validation for constraint: fractionDigits(2)
        if (!is_null($value) && mb_strlen(mb_substr($value, false !== mb_strpos($value, '.') ? mb_strpos($value, '.') + 1 : mb_strlen($value))) > 2) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, the value must at most contain 2 fraction digits, %d given', var_export($value, true), mb_strlen(mb_substr($value, mb_strpos($value, '.') + 1))), __LINE__);
        }
        $this->value = $value;
        return $this;
    }
    /**
     * Get productEan value
     * @return string|null
     */
    public function getProductEan()
    {
        return $this->productEan;
    }
    /**
     * Set productEan value
     * @param string $productEan
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setProductEan($productEan = null)
    {
        // validation for constraint: string
        if (!is_null($productEan) && !is_string($productEan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productEan, true), gettype($productEan)), __LINE__);
        }
        // validation for constraint: maxLength(24)
        if (!is_null($productEan) && mb_strlen($productEan) > 24) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 24', mb_strlen($productEan)), __LINE__);
        }
        $this->productEan = $productEan;
        return $this;
    }
    /**
     * Get productNameEn value
     * @return string|null
     */
    public function getProductNameEn()
    {
        return $this->productNameEn;
    }
    /**
     * Set productNameEn value
     * @param string $productNameEn
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setProductNameEn($productNameEn = null)
    {
        // validation for constraint: string
        if (!is_null($productNameEn) && !is_string($productNameEn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productNameEn, true), gettype($productNameEn)), __LINE__);
        }
        // validation for constraint: maxLength(32)
        if (!is_null($productNameEn) && mb_strlen($productNameEn) > 32) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 32', mb_strlen($productNameEn)), __LINE__);
        }
        $this->productNameEn = $productNameEn;
        return $this;
    }
    /**
     * Get productName value
     * @return string|null
     */
    public function getProductName()
    {
        return $this->productName;
    }
    /**
     * Set productName value
     * @param string $productName
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setProductName($productName = null)
    {
        // validation for constraint: string
        if (!is_null($productName) && !is_string($productName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($productName, true), gettype($productName)), __LINE__);
        }
        // validation for constraint: maxLength(32)
        if (!is_null($productName) && mb_strlen($productName) > 32) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 32', mb_strlen($productName)), __LINE__);
        }
        $this->productName = $productName;
        return $this;
    }
    /**
     * Get unitsCount value
     * @return int|null
     */
    public function getUnitsCount()
    {
        return $this->unitsCount;
    }
    /**
     * Set unitsCount value
     * @param int $unitsCount
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setUnitsCount($unitsCount = 0)
    {
        // validation for constraint: int
        if (!is_null($unitsCount) && !(is_int($unitsCount) || ctype_digit($unitsCount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($unitsCount, true), gettype($unitsCount)), __LINE__);
        }
        $this->unitsCount = $unitsCount;
        return $this;
    }
    /**
     * Get countryOfOrigin value
     * @return string|null
     */
    public function getCountryOfOrigin()
    {
        return $this->countryOfOrigin;
    }
    /**
     * Set countryOfOrigin value
     * @param string $countryOfOrigin
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setCountryOfOrigin($countryOfOrigin = null)
    {
        // validation for constraint: string
        if (!is_null($countryOfOrigin) && !is_string($countryOfOrigin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryOfOrigin, true), gettype($countryOfOrigin)), __LINE__);
        }
        // validation for constraint: maxLength(16)
        if (!is_null($countryOfOrigin) && mb_strlen($countryOfOrigin) > 16) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 16', mb_strlen($countryOfOrigin)), __LINE__);
        }
        $this->countryOfOrigin = $countryOfOrigin;
        return $this;
    }
    /**
     * Get currency value
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->currency;
    }
    /**
     * Set currency value
     * @param string $currency
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setCurrency($currency = null)
    {
        // validation for constraint: string
        if (!is_null($currency) && !is_string($currency)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currency, true), gettype($currency)), __LINE__);
        }
        // validation for constraint: maxLength(16)
        if (!is_null($currency) && mb_strlen($currency) > 16) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 16', mb_strlen($currency)), __LINE__);
        }
        $this->currency = $currency;
        return $this;
    }
    /**
     * Get invoiceNumber value
     * @return string|null
     */
    public function getInvoiceNumber()
    {
        return $this->invoiceNumber;
    }
    /**
     * Set invoiceNumber value
     * @param string $invoiceNumber
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setInvoiceNumber($invoiceNumber = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceNumber) && !is_string($invoiceNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceNumber, true), gettype($invoiceNumber)), __LINE__);
        }
        // validation for constraint: maxLength(16)
        if (!is_null($invoiceNumber) && mb_strlen($invoiceNumber) > 16) {
            throw new \InvalidArgumentException(sprintf('Invalid length of %s, the number of characters/octets contained by the literal must be less than or equal to 16', mb_strlen($invoiceNumber)), __LINE__);
        }
        $this->invoiceNumber = $invoiceNumber;
        return $this;
    }
    /**
     * Get invoiceIssueDate value
     * @return string|null
     */
    public function getInvoiceIssueDate()
    {
        return $this->invoiceIssueDate;
    }
    /**
     * Set invoiceIssueDate value
     * @param string $invoiceIssueDate
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setInvoiceIssueDate($invoiceIssueDate = null)
    {
        // validation for constraint: string
        if (!is_null($invoiceIssueDate) && !is_string($invoiceIssueDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($invoiceIssueDate, true), gettype($invoiceIssueDate)), __LINE__);
        }
        $this->invoiceIssueDate = $invoiceIssueDate;
        return $this;
    }
    /**
     * Get weight value
     * @return int|null
     */
    public function getWeight()
    {
        return $this->weight;
    }
    /**
     * Set weight value
     * @param int $weight
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setWeight($weight = null)
    {
        // validation for constraint: int
        if (!is_null($weight) && !(is_int($weight) || ctype_digit($weight))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($weight, true), gettype($weight)), __LINE__);
        }
        $this->weight = $weight;
        return $this;
    }
    /**
     * Get isFoodBook value
     * @return bool|null
     */
    public function getIsFoodBook()
    {
        return $this->isFoodBook;
    }
    /**
     * Set isFoodBook value
     * @param bool $isFoodBook
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setIsFoodBook($isFoodBook = null)
    {
        // validation for constraint: boolean
        if (!is_null($isFoodBook) && !is_bool($isFoodBook)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isFoodBook, true), gettype($isFoodBook)), __LINE__);
        }
        $this->isFoodBook = $isFoodBook;
        return $this;
    }
    /**
     * Get isVoc value
     * @return bool|null
     */
    public function getIsVoc()
    {
        return $this->isVoc;
    }
    /**
     * Set isVoc value
     * @param bool $isVoc
     * @return \WpifyWoo\PacketeraSDK\StructType\CustomsDeclarationItem
     */
    public function setIsVoc($isVoc = null)
    {
        // validation for constraint: boolean
        if (!is_null($isVoc) && !is_bool($isVoc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isVoc, true), gettype($isVoc)), __LINE__);
        }
        $this->isVoc = $isVoc;
        return $this;
    }
}
