<?php

namespace WpifyWoo\PacketeraSDK\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExternalStatusRecord StructType
 * @subpackage Structs
 */
class ExternalStatusRecord extends AbstractStructBase
{
    /**
     * The dateTime
     * @var string
     */
    public $dateTime;
    /**
     * The carrierClass
     * @var string
     */
    public $carrierClass;
    /**
     * The statusCode
     * @var string
     */
    public $statusCode;
    /**
     * The externalStatusName
     * @var string
     */
    public $externalStatusName;
    /**
     * The externalNote
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $externalNote;
    /**
     * The externalTrackingCode
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $externalTrackingCode;
    /**
     * Constructor method for ExternalStatusRecord
     * @uses ExternalStatusRecord::setDateTime()
     * @uses ExternalStatusRecord::setCarrierClass()
     * @uses ExternalStatusRecord::setStatusCode()
     * @uses ExternalStatusRecord::setExternalStatusName()
     * @uses ExternalStatusRecord::setExternalNote()
     * @uses ExternalStatusRecord::setExternalTrackingCode()
     * @param string $dateTime
     * @param string $carrierClass
     * @param string $statusCode
     * @param string $externalStatusName
     * @param string $externalNote
     * @param string $externalTrackingCode
     */
    public function __construct($dateTime = null, $carrierClass = null, $statusCode = null, $externalStatusName = null, $externalNote = null, $externalTrackingCode = null)
    {
        $this
            ->setDateTime($dateTime)
            ->setCarrierClass($carrierClass)
            ->setStatusCode($statusCode)
            ->setExternalStatusName($externalStatusName)
            ->setExternalNote($externalNote)
            ->setExternalTrackingCode($externalTrackingCode);
    }
    /**
     * Get dateTime value
     * @return string|null
     */
    public function getDateTime()
    {
        return $this->dateTime;
    }
    /**
     * Set dateTime value
     * @param string $dateTime
     * @return \WpifyWoo\PacketeraSDK\StructType\ExternalStatusRecord
     */
    public function setDateTime($dateTime = null)
    {
        // validation for constraint: string
        if (!is_null($dateTime) && !is_string($dateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateTime, true), gettype($dateTime)), __LINE__);
        }
        $this->dateTime = $dateTime;
        return $this;
    }
    /**
     * Get carrierClass value
     * @return string|null
     */
    public function getCarrierClass()
    {
        return $this->carrierClass;
    }
    /**
     * Set carrierClass value
     * @param string $carrierClass
     * @return \WpifyWoo\PacketeraSDK\StructType\ExternalStatusRecord
     */
    public function setCarrierClass($carrierClass = null)
    {
        // validation for constraint: string
        if (!is_null($carrierClass) && !is_string($carrierClass)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($carrierClass, true), gettype($carrierClass)), __LINE__);
        }
        $this->carrierClass = $carrierClass;
        return $this;
    }
    /**
     * Get statusCode value
     * @return string|null
     */
    public function getStatusCode()
    {
        return $this->statusCode;
    }
    /**
     * Set statusCode value
     * @param string $statusCode
     * @return \WpifyWoo\PacketeraSDK\StructType\ExternalStatusRecord
     */
    public function setStatusCode($statusCode = null)
    {
        // validation for constraint: string
        if (!is_null($statusCode) && !is_string($statusCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($statusCode, true), gettype($statusCode)), __LINE__);
        }
        $this->statusCode = $statusCode;
        return $this;
    }
    /**
     * Get externalStatusName value
     * @return string|null
     */
    public function getExternalStatusName()
    {
        return $this->externalStatusName;
    }
    /**
     * Set externalStatusName value
     * @param string $externalStatusName
     * @return \WpifyWoo\PacketeraSDK\StructType\ExternalStatusRecord
     */
    public function setExternalStatusName($externalStatusName = null)
    {
        // validation for constraint: string
        if (!is_null($externalStatusName) && !is_string($externalStatusName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalStatusName, true), gettype($externalStatusName)), __LINE__);
        }
        $this->externalStatusName = $externalStatusName;
        return $this;
    }
    /**
     * Get externalNote value
     * @return string|null
     */
    public function getExternalNote()
    {
        return $this->externalNote;
    }
    /**
     * Set externalNote value
     * @param string $externalNote
     * @return \WpifyWoo\PacketeraSDK\StructType\ExternalStatusRecord
     */
    public function setExternalNote($externalNote = null)
    {
        // validation for constraint: string
        if (!is_null($externalNote) && !is_string($externalNote)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalNote, true), gettype($externalNote)), __LINE__);
        }
        $this->externalNote = $externalNote;
        return $this;
    }
    /**
     * Get externalTrackingCode value
     * @return string|null
     */
    public function getExternalTrackingCode()
    {
        return $this->externalTrackingCode;
    }
    /**
     * Set externalTrackingCode value
     * @param string $externalTrackingCode
     * @return \WpifyWoo\PacketeraSDK\StructType\ExternalStatusRecord
     */
    public function setExternalTrackingCode($externalTrackingCode = null)
    {
        // validation for constraint: string
        if (!is_null($externalTrackingCode) && !is_string($externalTrackingCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalTrackingCode, true), gettype($externalTrackingCode)), __LINE__);
        }
        $this->externalTrackingCode = $externalTrackingCode;
        return $this;
    }
}
